//+------------------------------------------------------------------+
//|                                                 Slider Multi.mq4 |
//|                                    Created by Mimp (at forex-tsd)|
//|                                                                  |
//+------------------------------------------------------------------+

//*---------------------------------------------------------------------------------------------------------------------------------*
//| This indicator allows you to alter up to 4 Values of an indicator (displayed in a separate_window) by adjusting the location    |
//| of Markers in relation to a scale of boxes in the chart_window, to be used like "sliders". Each box is labelled with the value  |   
//| (int) of a Value# which will be applied to the indicator in the separate_window if a Marker is placed within that box on the    |
//| chart. This saves time and effort of having to go through the hastle of multiple distracting clicks if you are trying to fine   |
//| tune the values of your indicator during testing, and provides a more intuitive understanding of the relation between many      |
//| values (without having to have those many values of the same indicator drawn on the screen at the same time).                   |
//| If you wish to change the way that the 4 Values are applied to the buffers of the indicator simply add buffers as you would do  |
//| normally, and then insert the relevant Value1, Value2, Value3 or Value4 in the correct place in lines 571 to 574.               |
//|                                                                                                                                 |
//| DISCLAIMER: Use this indicator at your own risk. Intended for optimization and backtesting only. Not intended for live trading. |
//|                                                                                                                                 |
//| Permission granted to alter, copy, distribute, improve or otherwise use my code here (for personal use, not for use in sale).   |
//| Thanks to phy (mql4.com) for the idea of only redrawing visible bars. (Code copied from http://forum.mql4.com/9594/page2).      |
//| Thanks to mladen (forex-tsd) for helping to tackle updates per tick.                                                            |
//| Thanks to Drey (forex factory) for pointing out how to refresh by hotkey (when no ticks are available).                         |    
//| (See http://www.forexfactory.com/showthread.php?t=267385).                                                                      |
//|                                                                                                                                 |
//| NOTES:                                                                                                                          |   
//| The period will only respond to movements in the Marker every tick. The code considers the Marker to "be" in the corner of the  |
//| Marker selection box (where the little tiny square dot is). If you lose the Marker, you will need to reload the indicator. Do   |
//| not move the boxes once they have been drawn, because the Marker responds to their original X and Y co-ordinates. If you wish to|
//| draw the chart objects in a different place then adjust these settings (in the Internal Variables section) before loading the   |
//| indicator. If you wish to use the indicator while offline or during non-trading hours (when there are no ticks), then simply    |                     
//| refresh the chart every time you move the Marker to a new period (by pressing Alt+C+R). Does not work well with minus numbers!  |
//*---------------------------------------------------------------------------------------------------------------------------------*

#property indicator_separate_window

#property indicator_buffers 4

#property indicator_color1 White
#property indicator_color2 Red
#property indicator_color3 Silver
#property indicator_color4 Silver

#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1

#property indicator_maximum 100
#property indicator_minimum 0

//#property indicator_level1 50
//#property indicator_level2 30
//#property indicator_level3 70
//#property indicator_levelstyle STYLE_DOT
//#property indicator_levelcolor Red

// External variables

extern string Value1_name = "Period%K";          // Values for slider line 1.
extern int Value1_from = 2;                    // Lowest value to be tested. Does not work well with minus numbers.
extern int Value1_to = 50;                     // Highest value to be tested. Must be less than 50 values. Does not work well with minus numbers.

extern string Value2_name = "Period%D";          // Values for slider line 2.
extern int Value2_from = 2;                    // Lowest value to be tested. Does not work well with minus numbers.
extern int Value2_to = 50;                     // Highest value to be tested. Must be less than 50 values. Does not work well with minus numbers.

extern string Value3_name = "Slowing";          // Values for slider line 3.
extern int Value3_from = 2;                    // Lowest value to be tested. Does not work well with minus numbers.
extern int Value3_to = 50;                     // Highest value to be tested. Must be less than 50 values. Does not work well with minus numbers.

extern string Value4_name = "Level";          // Values for slider line 4.
extern int Value4_from = 2;                    // Lowest value to be tested. Does not work well with minus numbers.
extern int Value4_to = 50;                     // Highest value to be tested. Must be less than 50 values. Does not work well with minus numbers.

extern color Value1Colour = Red;
extern color Value2Colour = Gold;
extern color Value3Colour = Lime;
extern color Value4Colour = Aqua;

// Internal variables                           // WARNING: The chart spacings may not automatically adjust if you change these.

int Corner = 2;                                 // Selects which corner of the chart the X and Y co-ordinates of objects relate to.
                                                // 0 = TopLeft, 2 = BottomLeft. To get the boxes to stick to the top of the chart, 
                                                // use 0. To get the boxes to stick to the bottom of the chart, use 2.

int StartValue_X = 50;                          // Default initial X co-ordinate for chart objects.
int StartValue_Y = 50;                          // Default initial Y co-ordinate for chart objects.
int Marker_StartValue_X = 50;                   // Adjust these following values up and down to move the objects in the chart window.
int Marker_StartValue_Y = 420;                  // WARNING: the marker will not update the period correctly if you
int Box_StartValue_X = 50;                      //          move objects around the chart once they have been drawn.
int Box_StartValue_Y = 420;                     //          If you wish to draw the chart objects in a different place
int Number_StartValue_X = 55;                   //          then adjust these settings before loading the indicator.
int Number_StartValue_Y = 420;                  //
int PeriodLabel_StartValue_X = 3;               //
int PeriodLabel_StartValue_Y = 24;              //

int IndicatorDefaultPeriod = 2;                 // The period which the indicator defaults to when the indicator is first loaded.
int NumberVerticalOffset = 20;                  // Distance of numbers above boxes.
int HorizontalOffset = 20;                      // Distance between boxes.
int MultipleLineVerticalOffset = 60;            // The vertical offset for each new row of boxes.

int MarkerType = 115;                           // Windings number.
int MarkerSize = 20;
int BoxType = 111;                              // Windings number.
int BoxSize = 20;
string NumberFont = "Arial";
int NumberFontSize = 10;
color NumberColour = White;
string PeriodLabelFont = "Arial";
int PeriodLabelFontSize = 14;

// Program variables

int OnceOnlyToggle;
int Marker_CurrentValue_X;
int Marker_CurrentValue_Y;
int boxperiod;
int boxcounter;
int counter;
string shortname;
int Value1;
int Value2;
int Value3;
int Value4;

// Arrays

int BoxPeriod1[200];                             
int BoxLeft1[200];                               
int BoxRight1[200];                              
int BoxTop1[200];                               
int BoxBottom1[200];                            
    
int BoxPeriod2[200];                             
int BoxLeft2[200];                               
int BoxRight2[200];                              
int BoxTop2[200];                               
int BoxBottom2[200];

int BoxPeriod3[200];                             
int BoxLeft3[200];                               
int BoxRight3[200];                              
int BoxTop3[200];                               
int BoxBottom3[200];

int BoxPeriod4[200];                             
int BoxLeft4[200];                               
int BoxRight4[200];                              
int BoxTop4[200];                               
int BoxBottom4[200];
           
//--- Buffers

double BufValue1[];
double BufValue2[];
double BufValue3[];
double BufValue4[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 

   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,BufValue1);
   SetIndexLabel(0,"BufValue1");
 
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,BufValue2); 
   SetIndexLabel(1,"BufValue2");   
 
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,BufValue3); 
   SetIndexLabel(2,"BufValue3");   
   
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,BufValue4); 
   SetIndexLabel(3,"BufValue4");     
   
   shortname = "Slider Multi";   
   IndicatorShortName(shortname);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
Comment("");   
   
counter = 0;   
while ( counter <= 4)
{
ObjectDelete("Marker"+counter);
ObjectDelete("ValueLabel"+counter);
counter++;
}     
   
counter = 0;   
boxperiod = 1000;  
while ( counter <= 4 )
{ 
   while ( boxperiod <= 1000)
   {
   ObjectDelete("Box"+counter+"_"+boxperiod);
   ObjectDelete("Number"+counter+"_"+boxperiod);
   boxperiod++;
   } 
counter++;
boxperiod = 0;
}       
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
	
	// Redraw indicator buffers only within the visible window ----
   for( int i = MathMax(WindowFirstVisibleBar(), Bars-IndicatorCounted()); i>= 0; i--)
   {  
//----


// ************************************************************************************************************************
// Code in this section only runs the first time the indicator is loaded --------------------------------------------------
if ( OnceOnlyToggle == 0 )
{
// ---- OnceOnlyToggle start ----------------------------------------------------------------------------------------------

// Warn if more than 50 values chosen for any given Value# ----
if (
      ( (Value1_to - Value1_from) > 50 ) 
   || ( (Value2_to - Value2_from) > 50 )  
   || ( (Value3_to - Value3_from) > 50 ) 
   || ( (Value4_to - Value4_from) > 50 )         
   )
   {
   Comment("!WARNING! Each Value may only be tested for up to 50 possibilities. Reduce the relevant Value#_to value or Value#_from value.");
   Alert("!WARNING! Each Value may only be tested for up to 50 possibilities. Reduce the relevant Value#_to value or Value#_from value.");
   Print("!WARNING! Each Value may only be tested for up to 50 possibilities. Reduce the relevant Value#_to value or Value#_from value.");
   } 
   
// Warn if Value#_to is less than Value#_from ----
if (
      ( Value1_to < Value1_from ) 
   || ( Value2_to < Value2_from )   
   || ( Value3_to < Value3_from ) 
   || ( Value4_to < Value4_from )  
   )
   {
   Comment("!WARNING! a Value#_to has been set to less than a Value#_from in the external variables. Indicator will not work properly like this.");
   Alert("!WARNING! a Value#_to has been set to less than a Value#_from in the external variables. Indicator will not work properly like this.");
   Print("!WARNING! a Value#_to has been set to less than a Value#_from in the external variables. Indicator will not work properly like this.");
   }  

// Set start co-ordinates ----

int Marker_StartValue_X = StartValue_X;                  
int Marker_StartValue_Y = StartValue_Y;                
int Box_StartValue_X = StartValue_X;                   
int Box_StartValue_Y = StartValue_Y;                   
int Number_StartValue_X = StartValue_X + 5;                 
int Number_StartValue_Y = StartValue_Y;       
   
// Marker1 creation ----
   {
   ObjectCreate("Marker1", OBJ_LABEL, 0, 0, 0);
   ObjectSet("Marker1", OBJPROP_CORNER, Corner);   
   ObjectSet("Marker1", OBJPROP_XDISTANCE, Marker_StartValue_X);
   ObjectSet("Marker1", OBJPROP_YDISTANCE, Marker_StartValue_Y);
   ObjectSetText("Marker1",CharToStr(MarkerType),MarkerSize,"Wingdings",Value1Colour);
   }

// Marker2 creation ----
   {
   ObjectCreate("Marker2", OBJ_LABEL, 0, 0, 0);
   ObjectSet("Marker2", OBJPROP_CORNER, Corner);   
   ObjectSet("Marker2", OBJPROP_XDISTANCE, Marker_StartValue_X);
   ObjectSet("Marker2", OBJPROP_YDISTANCE, Marker_StartValue_Y + (MultipleLineVerticalOffset));
   ObjectSetText("Marker2",CharToStr(MarkerType),MarkerSize,"Wingdings",Value2Colour);
   }

// Marker3 creation ----
   {
   ObjectCreate("Marker3", OBJ_LABEL, 0, 0, 0);
   ObjectSet("Marker3", OBJPROP_CORNER, Corner);   
   ObjectSet("Marker3", OBJPROP_XDISTANCE, Marker_StartValue_X);
   ObjectSet("Marker3", OBJPROP_YDISTANCE, Marker_StartValue_Y + (MultipleLineVerticalOffset*2));
   ObjectSetText("Marker3",CharToStr(MarkerType),MarkerSize,"Wingdings",Value3Colour);
   }   

// Marker4 creation ----
   {
   ObjectCreate("Marker4", OBJ_LABEL, 0, 0, 0);
   ObjectSet("Marker4", OBJPROP_CORNER, Corner);   
   ObjectSet("Marker4", OBJPROP_XDISTANCE, Marker_StartValue_X);
   ObjectSet("Marker4", OBJPROP_YDISTANCE, Marker_StartValue_Y + (MultipleLineVerticalOffset*3));
   ObjectSetText("Marker4",CharToStr(MarkerType),MarkerSize,"Wingdings",Value4Colour);
   }
  
// Box creation cycle for Value1 ----
boxcounter = 0;
boxperiod = Value1_from;
while ( boxperiod <= (Value1_from + 50) )
{
if (
      ( Value1_from <= boxperiod )
   && ( Value1_to >= boxperiod )
   )
   {
   ObjectCreate("Box1_"+boxperiod, OBJ_LABEL, 0, 0, 0);
   ObjectSet("Box1_"+boxperiod, OBJPROP_CORNER, Corner);   
   ObjectSet("Box1_"+boxperiod, OBJPROP_XDISTANCE, Box_StartValue_X + (HorizontalOffset*(boxcounter+1)));
   ObjectSet("Box1_"+boxperiod, OBJPROP_YDISTANCE, Box_StartValue_Y);
   ObjectSetText("Box1_"+boxperiod,CharToStr(BoxType),BoxSize,"Wingdings",Value1Colour);  
   ObjectCreate("Number1_"+boxperiod, OBJ_LABEL, 0, 0, 0);  
   ObjectSet("Number1_"+boxperiod, OBJPROP_CORNER, Corner);     
   ObjectSet("Number1_"+boxperiod, OBJPROP_XDISTANCE, Number_StartValue_X + (HorizontalOffset*(boxcounter+1)));
   ObjectSet("Number1_"+boxperiod, OBJPROP_YDISTANCE, Number_StartValue_Y - NumberVerticalOffset);     
   ObjectSetText("Number1_"+boxperiod, ""+boxperiod, NumberFontSize, NumberFont, NumberColour);    
   BoxPeriod1[boxcounter] = boxperiod;  
   BoxLeft1[boxcounter] = (Box_StartValue_X + 25) + (HorizontalOffset*(boxcounter));
   BoxRight1[boxcounter] =  (Box_StartValue_X + 39) + (HorizontalOffset*(boxcounter));  
   BoxTop1[boxcounter] = Number_StartValue_Y + 7;
   BoxBottom1[boxcounter] = Number_StartValue_Y + 20;      
   boxcounter++;   
   }
boxperiod++;                            
}

// Box creation cycle for Value2 ----
boxcounter = 50;
boxperiod = Value2_from;
while ( boxperiod <= (Value2_from + 50) )
{
if (
      ( Value2_from <= boxperiod )
   && ( Value2_to >= boxperiod )
   )
   {
   ObjectCreate("Box2_"+boxperiod, OBJ_LABEL, 0, 0, 0);
   ObjectSet("Box2_"+boxperiod, OBJPROP_CORNER, Corner);     
   ObjectSet("Box2_"+boxperiod, OBJPROP_XDISTANCE, Box_StartValue_X + (HorizontalOffset*(boxcounter-49)));
   ObjectSet("Box2_"+boxperiod, OBJPROP_YDISTANCE, Box_StartValue_Y + MultipleLineVerticalOffset);
   ObjectSetText("Box2_"+boxperiod,CharToStr(BoxType),BoxSize,"Wingdings",Value2Colour);  
   ObjectCreate("Number2_"+boxperiod, OBJ_LABEL, 0, 0, 0);
   ObjectSet("Number2_"+boxperiod, OBJPROP_CORNER, Corner);        
   ObjectSet("Number2_"+boxperiod, OBJPROP_XDISTANCE, (Number_StartValue_X + (HorizontalOffset*(boxcounter-49))));
   ObjectSet("Number2_"+boxperiod, OBJPROP_YDISTANCE, (Number_StartValue_Y - NumberVerticalOffset) + MultipleLineVerticalOffset);     
   ObjectSetText("Number2_"+boxperiod, ""+boxperiod, NumberFontSize, NumberFont, NumberColour);    
   BoxPeriod2[boxcounter] = boxperiod;  
   BoxLeft2[boxcounter] = (Box_StartValue_X + 25) + (HorizontalOffset*(boxcounter-50));
   BoxRight2[boxcounter] =  ((Box_StartValue_X + 39) + (HorizontalOffset*(boxcounter-50)));  
   BoxTop2[boxcounter] = Number_StartValue_Y + 7 + MultipleLineVerticalOffset;
   BoxBottom2[boxcounter] = Number_StartValue_Y + 20 + MultipleLineVerticalOffset;  
   boxcounter++;   
   }
boxperiod++;                            
}

// Box creation cycle for Value3 ----
boxcounter = 100;
boxperiod = Value3_from;
while ( boxperiod <= (Value3_from + 50) )
{
if (
      ( Value3_from <= boxperiod )
   && ( Value3_to >= boxperiod )
   )
   {
   ObjectCreate("Box3_"+boxperiod, OBJ_LABEL, 0, 0, 0);
   ObjectSet("Box3_"+boxperiod, OBJPROP_CORNER, Corner);     
   ObjectSet("Box3_"+boxperiod, OBJPROP_XDISTANCE, (Box_StartValue_X) + ((HorizontalOffset)*(boxcounter-99)));
   ObjectSet("Box3_"+boxperiod, OBJPROP_YDISTANCE, Box_StartValue_Y + (MultipleLineVerticalOffset*2));
   ObjectSetText("Box3_"+boxperiod,CharToStr(BoxType),BoxSize,"Wingdings",Value3Colour);  
   ObjectCreate("Number3_"+boxperiod, OBJ_LABEL, 0, 0, 0);  
   ObjectSet("Number3_"+boxperiod, OBJPROP_CORNER, Corner);      
   ObjectSet("Number3_"+boxperiod, OBJPROP_XDISTANCE, ((Number_StartValue_X) + ((HorizontalOffset)*(boxcounter-99))));
   ObjectSet("Number3_"+boxperiod, OBJPROP_YDISTANCE, (Number_StartValue_Y - NumberVerticalOffset) + (MultipleLineVerticalOffset*2));     
   ObjectSetText("Number3_"+boxperiod, ""+boxperiod, NumberFontSize, NumberFont, NumberColour);    
   BoxPeriod3[boxcounter] = boxperiod;  
   BoxLeft3[boxcounter] = (Box_StartValue_X + 20) + ((HorizontalOffset)*(boxcounter-100));
   BoxRight3[boxcounter] =  ((Box_StartValue_X + 34) + ((HorizontalOffset)*(boxcounter-100)));  
   BoxTop3[boxcounter] = Number_StartValue_Y + 7 + (MultipleLineVerticalOffset*2);
   BoxBottom3[boxcounter] = Number_StartValue_Y + 20 + (MultipleLineVerticalOffset*2);  
   boxcounter++;   
   }
boxperiod++;                            
}

// Box creation cycle for Value4 ----
boxcounter = 150;
boxperiod = Value4_from;
while ( boxperiod <= (Value4_from + 50) )
{
if (
      ( Value4_from <= boxperiod )
   && ( Value4_to >= boxperiod )
   )
   {
   ObjectCreate("Box4_"+boxperiod, OBJ_LABEL, 0, 0, 0);
   ObjectSet("Box4_"+boxperiod, OBJPROP_CORNER, Corner);     
   ObjectSet("Box4_"+boxperiod, OBJPROP_XDISTANCE, (Box_StartValue_X) + ((HorizontalOffset)*(boxcounter-149)));
   ObjectSet("Box4_"+boxperiod, OBJPROP_YDISTANCE, Box_StartValue_Y + (MultipleLineVerticalOffset*3));
   ObjectSetText("Box4_"+boxperiod,CharToStr(BoxType),BoxSize,"Wingdings",Value4Colour);  
   ObjectCreate("Number4_"+boxperiod, OBJ_LABEL, 0, 0, 0);  
   ObjectSet("Number4_"+boxperiod, OBJPROP_CORNER, Corner);      
   ObjectSet("Number4_"+boxperiod, OBJPROP_XDISTANCE, ((Number_StartValue_X) + ((HorizontalOffset)*(boxcounter-149))));
   ObjectSet("Number4_"+boxperiod, OBJPROP_YDISTANCE, (Number_StartValue_Y - NumberVerticalOffset) + (MultipleLineVerticalOffset*3));     
   ObjectSetText("Number4_"+boxperiod, ""+boxperiod, NumberFontSize, NumberFont, NumberColour);    
   BoxPeriod4[boxcounter] = boxperiod;  
   BoxLeft4[boxcounter] = (Box_StartValue_X + 20) + ((HorizontalOffset)*(boxcounter-150));
   BoxRight4[boxcounter] =  ((Box_StartValue_X + 34) + ((HorizontalOffset)*(boxcounter-150)));  
   BoxTop4[boxcounter] = Number_StartValue_Y + 7 + (MultipleLineVerticalOffset*3);
   BoxBottom4[boxcounter] = Number_StartValue_Y + 20 + (MultipleLineVerticalOffset*3);  
   boxcounter++;   
   }
boxperiod++;                            
}

// ---- OnceOnlyToggle end ----------------------------------------------------------------------------------------------------
}
{ OnceOnlyToggle = 1; }
/// ---------------------------------------------------------------------------------------------------------------------------


// ****************************************************************************************************************************
// Code runs every tick from here onwards -------------------------------------------------------------------------------------

// Marker1 location check cycle. Checks location of Marker on screen and returns the value of whichever box it is in ----
boxcounter = 0;
while ( boxcounter <= 50 )
{
if ( 
      ( ObjectGet("Marker1", OBJPROP_XDISTANCE) >= BoxLeft1[boxcounter] )
   && ( ObjectGet("Marker1", OBJPROP_XDISTANCE) <= BoxRight1[boxcounter] )  
   && ( ObjectGet("Marker1", OBJPROP_YDISTANCE) >= BoxTop1[boxcounter] ) 
   && ( ObjectGet("Marker1", OBJPROP_YDISTANCE) <= BoxBottom1[boxcounter] ) 
   )
   {
   Value1 = BoxPeriod1[boxcounter];
   }
boxcounter++;
}

// Marker2 location check cycle. Checks location of Marker on screen and returns the value of whichever box it is in ----
boxcounter = 51;
while ( boxcounter <= 100 )
{
if ( 
      ( ObjectGet("Marker2", OBJPROP_XDISTANCE) >= BoxLeft2[boxcounter] )
   && ( ObjectGet("Marker2", OBJPROP_XDISTANCE) <= BoxRight2[boxcounter] )  
   && ( ObjectGet("Marker2", OBJPROP_YDISTANCE) >= BoxTop2[boxcounter] ) 
   && ( ObjectGet("Marker2", OBJPROP_YDISTANCE) <= BoxBottom2[boxcounter] ) 
   )
   {
   Value2 = BoxPeriod2[boxcounter];
   }
boxcounter++;
}

// Marker3 location check cycle. Checks location of Marker on screen and returns the value of whichever box it is in ----
boxcounter = 101;
while ( boxcounter <= 150 )
{
if ( 
      ( ObjectGet("Marker3", OBJPROP_XDISTANCE) >= BoxLeft3[boxcounter] )
   && ( ObjectGet("Marker3", OBJPROP_XDISTANCE) <= BoxRight3[boxcounter] )  
   && ( ObjectGet("Marker3", OBJPROP_YDISTANCE) >= BoxTop3[boxcounter] ) 
   && ( ObjectGet("Marker3", OBJPROP_YDISTANCE) <= BoxBottom3[boxcounter] ) 
   )
   {
   Value3 = BoxPeriod3[boxcounter];
   }
boxcounter++;
}

// Marker4 location check cycle. Checks location of Marker on screen and returns the value of whichever box it is in ----
boxcounter = 151;
while ( boxcounter <= 200 )
{
if ( 
      ( ObjectGet("Marker4", OBJPROP_XDISTANCE) >= BoxLeft4[boxcounter] )
   && ( ObjectGet("Marker4", OBJPROP_XDISTANCE) <= BoxRight4[boxcounter] )  
   && ( ObjectGet("Marker4", OBJPROP_YDISTANCE) >= BoxTop4[boxcounter] ) 
   && ( ObjectGet("Marker4", OBJPROP_YDISTANCE) <= BoxBottom4[boxcounter] ) 
   )
   {
   Value4 = BoxPeriod4[boxcounter];
   }
boxcounter++;
}

// Assign a default value to the Values if no box has been selected by the relevant Marker ----
if (
      ( Value1 == 0 )
   || ( Value1 == EMPTY_VALUE )   
   )
   {
   Value1 = IndicatorDefaultPeriod;
   } 

if (
      ( Value2 == 0 )
   || ( Value2 == EMPTY_VALUE )   
   )
   {
   Value2 = IndicatorDefaultPeriod;
   } 

if (
      ( Value3 == 0 )
   || ( Value3 == EMPTY_VALUE )   
   )
   {
   Value3 = IndicatorDefaultPeriod;
   } 

if (
      ( Value4 == 0 )
   || ( Value4 == EMPTY_VALUE )   
   )
   {
   Value4 = IndicatorDefaultPeriod;
   }            

// Draw label to show selected Value ----
   {
   ObjectCreate("ValueLabel1", OBJ_LABEL, 0, 0, 0);       
   ObjectSet("ValueLabel1", OBJPROP_XDISTANCE, PeriodLabel_StartValue_X);
   ObjectSet("ValueLabel1", OBJPROP_YDISTANCE, PeriodLabel_StartValue_Y);     
   ObjectSetText("ValueLabel1", Value1_name+" = "+Value1, PeriodLabelFontSize, PeriodLabelFont, Value1Colour);  
   }

   {
   ObjectCreate("ValueLabel2", OBJ_LABEL, 0, 0, 0);     
   ObjectSet("ValueLabel2", OBJPROP_XDISTANCE, PeriodLabel_StartValue_X);
   ObjectSet("ValueLabel2", OBJPROP_YDISTANCE, PeriodLabel_StartValue_Y + 30);     
   ObjectSetText("ValueLabel2", Value2_name+" = "+Value2, PeriodLabelFontSize, PeriodLabelFont, Value2Colour);  
   }

   {
   ObjectCreate("ValueLabel3", OBJ_LABEL, 0, 0, 0);    
   ObjectSet("ValueLabel3", OBJPROP_XDISTANCE, PeriodLabel_StartValue_X);
   ObjectSet("ValueLabel3", OBJPROP_YDISTANCE, PeriodLabel_StartValue_Y + 60);     
   ObjectSetText("ValueLabel3", Value3_name+" = "+Value3, PeriodLabelFontSize, PeriodLabelFont, Value3Colour);  
   }   
 
   {
   ObjectCreate("ValueLabel4", OBJ_LABEL, 0, 0, 0);    
   ObjectSet("ValueLabel4", OBJPROP_XDISTANCE, PeriodLabel_StartValue_X);
   ObjectSet("ValueLabel4", OBJPROP_YDISTANCE, PeriodLabel_StartValue_Y + 90);     
   ObjectSetText("ValueLabel4", Value4_name+" = "+Value4, PeriodLabelFontSize, PeriodLabelFont, Value4Colour);  
   }   
    
    
// ******************************************************************************************************************************
// ** Insert your required buffers here ** 
// Update and redraw buffers with new Values. Insert Value1, Value2, Value3 or Value4 in the places you require ----
   {
   BufValue1[i] = iStochastic(Symbol(), 0, Value1, Value2, Value3, MODE_SMA, 1, 0, i);
   BufValue2[i] = iStochastic(Symbol(), 0, Value1, Value2, Value3, MODE_SMA, 1, 1, i);
   BufValue3[i] = Value4;
   BufValue4[i] = 100 - Value4;       
   WindowRedraw();   
   }
    
//----
}
   return(0);
  }
//+------------------------------------------------------------------+